# Help system, for Unix Micropolis.
#
# Micropolis, Unix Version.  This game was released for the Unix platform
# in or about 1990 and has been modified for inclusion in the One Laptop
# Per Child program.  Copyright (C) 1989 - 2007 Electronic Arts Inc.  If
# you need assistance with this program, you may contact:
#   http://wiki.laptop.org/go/Micropolis  or email  micropolis@laptop.org.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.  You should have received a
# copy of the GNU General Public License along with this program.  If
# not, see <http://www.gnu.org/licenses/>.
# 
#             ADDITIONAL TERMS per GNU GPL Section 7
# 
# No trademark or publicity rights are granted.  This license does NOT
# give you any right, title or interest in the trademark SimCity or any
# other Electronic Arts trademark.  You may not distribute any
# modification of this program using the trademark SimCity or claim any
# affliation or association with Electronic Arts Inc. or its employees.
# 
# Any propagation or conveyance of this program must include this
# copyright notice and these terms.
# 
# If you convey this program (or any modifications of it) and assume
# contractual liability for the program to recipients of it, you agree
# to indemnify Electronic Arts for any liability that those contractual
# assumptions impose on Electronic Arts.
# 
# You may not misrepresent the origins of this program; modified
# versions of the program must be marked as such and not identified as
# the original program.
# 
# This disclaimer supplements the one included in the General Public
# License.  TO THE FULLEST EXTENT PERMISSIBLE UNDER APPLICABLE LAW, THIS
# PROGRAM IS PROVIDED TO YOU "AS IS," WITH ALL FAULTS, WITHOUT WARRANTY
# OF ANY KIND, AND YOUR USE IS AT YOUR SOLE RISK.  THE ENTIRE RISK OF
# SATISFACTORY QUALITY AND PERFORMANCE RESIDES WITH YOU.  ELECTRONIC ARTS
# DISCLAIMS ANY AND ALL EXPRESS, IMPLIED OR STATUTORY WARRANTIES,
# INCLUDING IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY QUALITY,
# FITNESS FOR A PARTICULAR PURPOSE, NONINFRINGEMENT OF THIRD PARTY
# RIGHTS, AND WARRANTIES (IF ANY) ARISING FROM A COURSE OF DEALING,
# USAGE, OR TRADE PRACTICE.  ELECTRONIC ARTS DOES NOT WARRANT AGAINST
# INTERFERENCE WITH YOUR ENJOYMENT OF THE PROGRAM; THAT THE PROGRAM WILL
# MEET YOUR REQUIREMENTS; THAT OPERATION OF THE PROGRAM WILL BE
# UNINTERRUPTED OR ERROR-FREE, OR THAT THE PROGRAM WILL BE COMPATIBLE
# WITH THIRD PARTY SOFTWARE OR THAT ANY ERRORS IN THE PROGRAM WILL BE
# CORRECTED.  NO ORAL OR WRITTEN ADVICE PROVIDED BY ELECTRONIC ARTS OR
# ANY AUTHORIZED REPRESENTATIVE SHALL CREATE A WARRANTY.  SOME
# JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF OR LIMITATIONS ON IMPLIED
# WARRANTIES OR THE LIMITATIONS ON THE APPLICABLE STATUTORY RIGHTS OF A
# CONSUMER, SO SOME OR ALL OF THE ABOVE EXCLUSIONS AND LIMITATIONS MAY
# NOT APPLY TO YOU.

# Help messages to do:
# MicropolisMenu

# backstop help message

Help Window {Micropolis Window} \
{This is one of Micropolis's windows.
Press Help or Meta-Click on the other controls and graphics for more information about them.
[More help to come in a later version!  Sorry!]}

# AskQuestion button help

Help SelectCity.No {Keep Playing} \
{Press this button to keep playing with the current city simulation.}

Help SelectCity.Yes {Another City} \
{Press this vote button to abandon this city and choose another one to play with.}

Help Quit.No {Keep Playing Micropolis} \
{Press this button to continue playing this game of Micropolis.}

Help Quit.IQuit {Really Quit Micropolis} \
{Press this button to quit playing this game of Micropolis.}

Help Quit.IResign {Resign Micropolis} \
{Press this button to resign yourself from this game of Micropolis.}

Help Quit.AllQuit {Everyone Quit Micropolis} \
{Press this vote button to quit Micropolis if everyone else agrees.}

Help Plan.Veto {Veto Plan} \
{Press this button to veto the plan.}

Help Plan.Goto {Goto Plan} \
{Press this button to scroll your editor window to the planned location.}

Help Plan.Support {Support Plan} \
{Press this vote button to support the plan.}

Help Disaster.Yes {Cause a Disaster} \
{Press this button to cause a disaster.}

Help Disaster.No {Don't Cause a Disaster} \
{Press this button to avoid causing a disaster.}

# head window help

Help Head {Micropolis Controls Window} {}
Help Head.MicropolisMenu {Micropolis Main Menu} {}
Help Head.OptionsMenu {Options Menu} {}
Help Head.DisastersMenu {Disasters Menu} {}
Help Head.TimeMenu {Time Menu} {}
Help Head.PriorityMenu {Priority Menu} {}
Help Head.WindowsMenu {Windows Menu} {}
Help Head.Date {Micropolis Date Display} {}
Help Head.Funds {Micropolis Funds Display} {}
Help Head.Graph {Res Com Ind History Graph} {}
Help Head.Demand {Res Com Ind Demand Gauge} {}
Help Head.Log {Scrolling Message Log} {}
Help Head.Scrollbar {Message Log Scrollbar} {}
Help Head.Chat {Chat Push Button} {}
Help Head.Entry {Text Entry Field} {}

# notice window help

Help Notice {Micropolis Notice Window} {}
Help Notice.Title {Notice Title} {}
Help Notice.Text {Notice Text} {}
Help Notice.Dismiss {Notice Dismiss Button} {}
Help Notice.View {Notice Map View} {}

# help window help

Help Help {Micropolis Help Window} {}
Help Help.Title {Help Title} {}
Help Help.Scrollbar {Help Text Scrollbar} {}
Help Help.Text {Help Text} {}
Help Help.Dismiss {Help Dismiss Button} {}

# frob window help

Help Frob {Micropolis Frob-O-Matic Dynamic Zone Filter} {This bank of (min/max) interval sliders adjust the filters for the dynamic zone map view. The zones that do not pass through the filter are invisible, and the zones passing through all the filters are displayed, as you adjust the filter intervals.}
Help Frob.Title {Frob Title} {}
Help Frob.PopulationDensity {Frob Population Density} {Adjust the minimum and maximum Population Density to display in the dynamic map zone menu.}
Help Frob.RateOfGrowth {Frob Rate Of Growth} {Adjust the minimum and maximum Rate Of Growth to display in the dynamic map zone menu.}
Help Frob.TrafficDensity {Frob Traffic Density} {Adjust the minimum and maximum Traffic Density to display in the dynamic map zone menu.}
Help Frob.PollutionRate {Frob Pollution Rate} {Adjust the minimum and maximum Pollution Rate to display in the dynamic map zone menu.}
Help Frob.CrimeRate {Frob Crime Rate} {Adjust the minimum and maximum Crime Rate to display in the dynamic map zone menu.}
Help Frob.LandValue {Frob Land Value} {Adjust the minimum and maximum Land Value to display in the dynamic map zone menu.}
Help Frob.PoliceEffect {Frob Police Effect} {Adjust the minimum and maximum Police Effect to display in the dynamic map zone menu.}
Help Frob.FireEffect {Frob Fire Effect} {Adjust the minimum and maximum Fire Effect to display in the dynamic map zone menu.}
Help Frob.Dismiss {Frob Dismiss Button} {}

# scenario window help

Help Scenario {Micropolis Chooser Window} {}
Help Scenario.NewCity {New City Button} {}
Help Scenario.LoadCity {Load City Button} {}
Help Scenario.Dullsville {Dullsville Scenario Button} {}
Help Scenario.SanFran {San Francisco Scenario Button} {}
Help Scenario.Hamburg {Hamburg Scenario Button} {}
Help Scenario.Bern {Bern Scenario Button} {}
Help Scenario.Tokyo {Tokyo Scenario Button} {}
Help Scenario.Rio {Rio de Janeiro Scenario Button} {}
Help Scenario.Boston {Boston Scenario Button} {}
Help Scenario.Detroit {Detroit Scenario Button} {}
Help Scenario.Previous {Previous Map Button} {}
Help Scenario.Use {Use This Map Button} {}
Help Scenario.Next {Next Map Button} {}
Help Scenario.Name {City Name Entry Field} {}
Help Scenario.Level {Game Level Buttons} {}

# map window help

Help Map {Micropolis Map Window} {}
Help Map.View {Map View} {}
Help Map.Zones {Map Zones Menu} {}
Help Map.Overlays {Map Overlays Menu} {}

# editor window help

Help Editor {Micropolis Editor Window} {}
Help Editor.Display {Editor Display Menu} {}
Help Editor.Options {Editor Options Menu} {}
Help Editor.Message {Editor Message Banner} {}
Help Editor.View {Editor View} {}
Help Editor.ToolPallet {Editor Tool Pallet} {}
Help Editor.ToolName {Editor Tool Name} {}
Help Editor.ToolCost {Editor Tool Cost} {}
Help Editor.ToolRes {Residential Zone Tool Icon} {}
Help Editor.ToolCom {Commercial Zone Tool Icon} {}
Help Editor.ToolInd {Industrial Zone Tool Icon} {}
Help Editor.ToolFire {Fire Station Tool Icon} {}
Help Editor.ToolQuery {Query Tool Icon} {}
Help Editor.ToolPolice {Police Station Tool Icon} {}
Help Editor.ToolWire {Wire Tool Icon} {}
Help Editor.ToolBulldozer {Bulldozer Tool Icon} {}
Help Editor.ToolRail {Rail Tool Icon} {}
Help Editor.ToolRoad {Road Tool Icon} {}
Help Editor.ToolChalk {Chalk Tool Icon} {}
Help Editor.ToolEraser {Eraser Tool Icon} {}
Help Editor.ToolStadium {Stadium Tool Icon} {}
Help Editor.ToolPark {Park Tool Icon} {}
Help Editor.ToolSeaport {Seaport Tool Icon} {}
Help Editor.ToolCoal {Coal Power Plant Tool Icon} {}
Help Editor.ToolNuclear {Nuclear Power Plant Tool Icon} {}
Help Editor.ToolAirport {Airport Tool Icon} {}
Help Editor.ToolPie {Editor Tool Pie Menu} {}
Help Editor.ZonePie {Editor Tool Zone Pie Menu} {}
Help Editor.BuildPie {Editor Tool Build Pie Menu} {}

# budget window help

Help Budget {Micropolis Budget Window} {}
Help Budget.Label {Paused to set the Budget} {}
Help Budget.Collected {Taxes Collected} {}
Help Budget.Flow {Cash Flow} {}
Help Budget.Previous {Previous Funds} {}
Help Budget.Current {Current Funds} {}
Help Budget.Road {Road Fund} {}
Help Budget.Fire {Fire Fund} {}
Help Budget.Police {Police Fund} {}
Help Budget.Tax {Tax Rate} {}
Help Budget.Continue {Continue With These Figures} {}
Help Budget.Reset {Reset to Original Figures} {}
Help Budget.Cancel {Cancel Changes and Continue} {}
Help Budget.AutoCancel {Automatic Cancel Timeout} {}

# graph window help

Help Graph {Micropolis Graph Window} {}
Help Graph.10Years {Graph 10 Year Scale} {}
Help Graph.120Years {Graph 120 Year Scale} {}
Help Graph.Res {Graph Residential Toggle} {}
Help Graph.Com {Graph Commercial Toggle} {}
Help Graph.Ind {Graph Industrial Toggle} {}
Help Graph.Money {Graph Cash Flow Toggle} {}
Help Graph.Crime {Graph Crime Toggle} {}
Help Graph.Pollution {Graph Pollution Toggle} {}
Help Graph.View {Graph View} {}
Help Graph.Dismiss {Dismiss Graph Window Button} {}

# evaluation window help

Help Evaluation {Micropolis Evaluation Window} {}
Help Evaluation.Opinion {Public Opinion} {}
Help Evaluation.GoodJob {Are You Doing a Good Job?} {}
Help Evaluation.WorstProblems {Your Worst Problems} {}
Help Evaluation.Statistics {Statistics} {}
Help Evaluation.Score {Score} {}
Help Evaluation.Dismiss {Dismiss Evaluation Window Button} {}

# ask window help

Help Ask {Micropolis Query Window} {}

# add player window

Help Player {Micropolis Player Window} {}
Help Player.Players {Displays of Micropolis Players} {}
Help Player.Display {Display of Player to Add} {}
Help Player.Dismiss {Dismiss Player Window Button} {}

# file window

Help File {Micropolis File Chooser Window} {}
Help File.List {List of File Names} {}
Help File.Directory {Directory Name} {}
Help File.File {File Name} {}
Help File.OK {OK Button} {}
Help File.Rescan {Rescan Directory} {}
Help File.Cancel {Cancel File Chooser} {}
